浏览代码

Add new analysis action

Signed-off-by: Andy Scherzinger <info@andy-scherzinger.de>
Andy Scherzinger 2 年之前
父节点
当前提交
9fdc1c2a6e

+ 49 - 0
.github/workflows/analysis.yml

@@ -0,0 +1,49 @@
+name: "Analysis"
+
+on:
+    pull_request:
+        branches: [ master, stable-* ]
+    push:
+        branches: [ master, stable-* ]
+
+permissions:
+    pull-requests: write
+    contents: write
+
+jobs:
+    analysis:
+        runs-on: ubuntu-latest
+        steps:
+            -   name: Setup variables
+                id: get-vars
+                run: |
+                    if [ -z "$GITHUB_HEAD_REF" ]; then
+                        # push
+                        echo "::set-output name=branch::$GITHUB_REF_NAME"
+                        echo "::set-output name=pr::$GITHUB_RUN_ID"
+                        echo "::set-output name=repo::${{ github.repository }}"
+                    else
+                        # pull request
+                        echo "::set-output name=branch::$GITHUB_HEAD_REF"
+                        echo "::set-output name=pr::${{ github.event.pull_request.number }}"
+                        echo "::set-output name=repo::${{ github.event.pull_request.head.repo.full_name }}"
+                    fi
+            -   uses: actions/checkout@v3
+                with:
+                    repository: ${{ steps.get-vars.outputs.repo }}
+                    ref: ${{ steps.get-vars.outputs.branch }}
+            -   name: Set up JDK 11
+                uses: actions/setup-java@v3
+                with:
+                    distribution: "temurin"
+                    java-version: 11
+            -   name: Install dependencies
+                run: |
+                    python3 -m pip install defusedxml
+            -   name: Run analysis wrapper
+                env:
+                    GITHUB_TOKEN: ${{ secrets.GITHUB_TOKEN }}
+                run: |
+                    mkdir -p $HOME/.gradle
+                    echo "org.gradle.jvmargs=-Xmx2g -XX:MaxMetaspaceSize=512m -XX:+HeapDumpOnOutOfMemoryError" > $HOME/.gradle/gradle.properties
+                    scripts/analysis/analysis-wrapper.sh ${{ steps.get-vars.outputs.branch }} ${{ secrets.LOG_USERNAME }} ${{ secrets.LOG_PASSWORD }} $GITHUB_RUN_NUMBER ${{ steps.get-vars.outputs.pr }}

+ 32 - 3
.gitignore

@@ -1,6 +1,7 @@
 # Built application files
 # Built application files
 *.apk
 *.apk
 *.ap_
 *.ap_
+*.aab
 
 
 # Files for the ART/Dalvik VM
 # Files for the ART/Dalvik VM
 *.dex
 *.dex
@@ -10,25 +11,36 @@
 
 
 # Generated files
 # Generated files
 bin/
 bin/
+build/
+*.iml
 gen/
 gen/
-out/
+target/
 
 
-# Local configuration file (sdk path, etc)
+# Local configuration files (sdk path, etc)
 local.properties
 local.properties
 tests/local.properties
 tests/local.properties
 
 
+# Mac .DS_Store files
+.DS_Store
+
 # Proguard folder generated by Eclipse
 # Proguard folder generated by Eclipse
 proguard/
 proguard/
+proguard-project.txt
+tests/proguard-project.txt
 
 
 # Log Files
 # Log Files
 *.log
 *.log
 
 
 # Android Studio and Gradle specific entries
 # Android Studio and Gradle specific entries
-*.iml
 .gradle
 .gradle
+.idea/*
+!.idea/codeStyles/
 .idea
 .idea
 build
 build
 /gradle.properties
 /gradle.properties
+.attach_pid*
+fastlane/Fastfile
+*.hprof
 captures/
 captures/
 .navigation/
 .navigation/
 app/gplay/
 app/gplay/
@@ -55,4 +67,21 @@ freeline/
 freeline_project_description.json
 freeline_project_description.json
 .DS_Store
 .DS_Store
 
 
+# fastlane specific
+**/fastlane/report.xml
+
+# deliver temporary files
+**/fastlane/Preview.html
+
+# snapshot generated screenshots
+**/fastlane/screenshots
+
+# scan temporary files
+**/fastlane/test_output
+/fastlane/vendor/
+/.bundle/
+/fastlane/.bundle
+
+# python
+**/__pycache__/
 
 

+ 6 - 3
app/build.gradle

@@ -131,10 +131,13 @@ android {
             excludeFilter = file("${project.rootDir}/spotbugs-filter.xml")
             excludeFilter = file("${project.rootDir}/spotbugs-filter.xml")
 
 
             reports {
             reports {
-                xml.enabled = false
+                xml {
+                    required = true
+                }
                 html {
                 html {
-                    enabled = true
-                    destination = file("$project.buildDir/reports/spotbugs/spotbugs.html")
+                    required = true
+                    outputLocation = file("$project.buildDir/reports/spotbugs/spotbugs.html")
+					stylesheet = 'fancy.xsl'
                 }
                 }
             }
             }
         }
         }

+ 1 - 1
build.gradle

@@ -37,7 +37,7 @@ buildscript {
         classpath 'com.android.tools.build:gradle:7.3.0'
         classpath 'com.android.tools.build:gradle:7.3.0'
         classpath "org.jetbrains.kotlin:kotlin-gradle-plugin:${kotlinVersion}"
         classpath "org.jetbrains.kotlin:kotlin-gradle-plugin:${kotlinVersion}"
         classpath "org.jetbrains.kotlin:kotlin-serialization:${kotlinVersion}"
         classpath "org.jetbrains.kotlin:kotlin-serialization:${kotlinVersion}"
-        classpath 'gradle.plugin.com.github.spotbugs.snom:spotbugs-gradle-plugin:4.7.5'
+        classpath 'com.github.spotbugs.snom:spotbugs-gradle-plugin:5.0.11'
         classpath "io.gitlab.arturbosch.detekt:detekt-gradle-plugin:1.21.0"
         classpath "io.gitlab.arturbosch.detekt:detekt-gradle-plugin:1.21.0"
         classpath "org.jlleitschuh.gradle:ktlint-gradle:11.0.0"
         classpath "org.jlleitschuh.gradle:ktlint-gradle:11.0.0"
 
 

+ 60 - 45
scripts/analysis/analysis-wrapper.sh

@@ -1,66 +1,59 @@
 #!/usr/bin/env bash
 #!/usr/bin/env bash
 
 
-#1: GIT_USERNAME
-#2: GIT_TOKEN
-#3: BRANCH
-#4: LOG_USERNAME
-#5: LOG_PASSWORD
-#6: DRONE_BUILD_NUMBER
-#7: PULL_REQUEST_NUMBER
+BRANCH=$1
+LOG_USERNAME=$2
+LOG_PASSWORD=$3
+BUILD_NUMBER=$4
+PR_NUMBER=$5
 
 
 
 
+stableBranch="master"
 repository="talk"
 repository="talk"
 
 
-stableBranch=$(git branch | grep '*' | cut -d' ' -f2)
-if [[ $stableBranch = \stable-* ]] ; then
-  stableBranch=$3
-else
-  stableBranch="master"
-fi
-
-ruby scripts/analysis/lint-up.rb $1 $2 $3
+ruby scripts/analysis/lint-up.rb
 lintValue=$?
 lintValue=$?
 
 
-ruby scripts/analysis/findbugs-up.rb $1 $2 $3
-findbugsValue=$?
+curl "https://www.kaminsky.me/nc-dev/$repository-findbugs/$stableBranch.xml" -o "/tmp/$stableBranch.xml"
+ruby scripts/analysis/spotbugs-up.rb "$stableBranch"
+spotbugsValue=$?
 
 
 # exit codes:
 # exit codes:
 # 0: count was reduced
 # 0: count was reduced
 # 1: count was increased
 # 1: count was increased
 # 2: count stayed the same
 # 2: count stayed the same
 
 
-echo "Branch: $3"
+source scripts/lib.sh
 
 
-if [ $3 = $stableBranch ]; then
-    echo "New findbugs result for $stableBranch at: https://www.kaminsky.me/nc-dev/$repository-findbugs/$stableBranch.html"
-    curl -k -u $4:$5 -X PUT https://nextcloud.kaminsky.me/remote.php/webdav/$repository-findbugs/$stableBranch.html --upload-file app/build/reports/spotbugs/spotbugs.html
+echo "Branch: $BRANCH"
 
 
-    summary=$(sed -n "/<h1>Summary<\/h1>/,/<h1>Warnings<\/h1>/p" app/build/reports/spotbugs/spotbugs.html | head -n-1 | sed s'/<\/a>//'g | sed s'/<a.*>//'g | sed s"/Summary/SpotBugs ($stableBranch)/" | tr "\"" "\'" | tr -d "\r\n")
-    curl -k -u $4:$5 -X PUT -d "$summary" https://nextcloud.kaminsky.me/remote.php/webdav/$repository-findbugs/findbugs-summary-$stableBranch.html
+if [ "$BRANCH" = $stableBranch ]; then
+    echo "New spotbugs result for $stableBranch at: https://www.kaminsky.me/nc-dev/$repository-findbugs/$stableBranch.html"
+    curl -u "${LOG_USERNAME}:${LOG_PASSWORD}" -X PUT https://nextcloud.kaminsky.me/remote.php/webdav/$repository-findbugs/$stableBranch.html --upload-file app/build/reports/spotbugs/spotbugs.html
+    curl 2>/dev/null -u "${LOG_USERNAME}:${LOG_PASSWORD}" -X PUT "https://nextcloud.kaminsky.me/remote.php/webdav/$repository-findbugs/$stableBranch.xml" --upload-file app/build/reports/spotbugs/gplayDebug.xml
 
 
     if [ $lintValue -ne 1 ]; then
     if [ $lintValue -ne 1 ]; then
         echo "New lint result for $stableBranch at: https://www.kaminsky.me/nc-dev/$repository-lint/$stableBranch.html"
         echo "New lint result for $stableBranch at: https://www.kaminsky.me/nc-dev/$repository-lint/$stableBranch.html"
-        curl -k -u $4:$5 -X PUT https://nextcloud.kaminsky.me/remote.php/webdav/$repository-lint/$stableBranch.html --upload-file app/build/reports/lint/lint.html
+        curl -u "${LOG_USERNAME}:${LOG_PASSWORD}" -X PUT https://nextcloud.kaminsky.me/remote.php/webdav/$repository-lint/$stableBranch.html --upload-file app/build/reports/lint/lint.html
         exit 0
         exit 0
     fi
     fi
 else
 else
-    if [ -e $6 ]; then
+    if [ -e "${BUILD_NUMBER}" ]; then
         6=$stableBranch"-"$(date +%F)
         6=$stableBranch"-"$(date +%F)
     fi
     fi
-    echo "New lint results at https://www.kaminsky.me/nc-dev/$repository-lint/$6.html"
-    curl -k -u $4:$5 -X PUT https://nextcloud.kaminsky.me/remote.php/webdav/$repository-lint/$6.html --upload-file app/build/reports/lint/lint.html
+    echo "New lint results at https://www.kaminsky.me/nc-dev/$repository-lint/${BUILD_NUMBER}.html"
+    curl 2>/dev/null -u "${LOG_USERNAME}:${LOG_PASSWORD}" -X PUT "https://nextcloud.kaminsky.me/remote.php/webdav/$repository-lint/${BUILD_NUMBER}.html" --upload-file app/build/reports/lint/lint.html
 
 
-    echo "New findbugs results at https://www.kaminsky.me/nc-dev/$repository-findbugs/$6.html"
-    curl -k -u $4:$5 -X PUT https://nextcloud.kaminsky.me/remote.php/webdav/$repository-findbugs/$6.html --upload-file app/build/reports/spotbugs/spotbugs.html
+    echo "New spotbugs results at https://www.kaminsky.me/nc-dev/$repository-findbugs/${BUILD_NUMBER}.html"
+    curl 2>/dev/null -u "${LOG_USERNAME}:${LOG_PASSWORD}" -X PUT "https://nextcloud.kaminsky.me/remote.php/webdav/$repository-findbugs/${BUILD_NUMBER}.html" --upload-file app/build/reports/spotbugs/spotbugs.html
 
 
-    # delete all old comments
-    oldComments=$(curl -k 2>/dev/null -u $1:$2 -X GET https://api.github.com/repos/nextcloud/talk-android/issues/$7/comments | jq '.[] | (.id |tostring) + "|" + (.user.login | test("nextcloud-android-bot") | tostring) ' | grep true | tr -d "\"" | cut -f1 -d"|")
+    # delete all old comments, starting with Codacy
+    oldComments=$(curl_gh -X GET "https://api.github.com/repos/nextcloud/$repository/issues/${PR_NUMBER}/comments" | jq '.[] | select((.user.login | contains("github-actions")) and  (.body | test("<h1>Codacy.*"))) | .id')
 
 
-    echo $oldComments | while read comment ; do
-        curl -k 2>/dev/null -u $1:$2 -X DELETE https://api.github.com/repos/nextcloud/talk-android/issues/comments/$comment
+    echo "$oldComments" | while read -r comment ; do
+        curl_gh -X DELETE "https://api.github.com/repos/nextcloud/$repository-android/issues/comments/$comment"
     done
     done
 
 
-    # lint and findbugs file must exist
+    # lint and spotbugs file must exist
     if [ ! -s app/build/reports/lint/lint.html ] ; then
     if [ ! -s app/build/reports/lint/lint.html ] ; then
         echo "lint.html file is missing!"
         echo "lint.html file is missing!"
         exit 1
         exit 1
@@ -84,7 +77,7 @@ else
         lintWarningNew=0
         lintWarningNew=0
     fi
     fi
 
 
-    lintResultOld=$(curl -k 2>/dev/null https://raw.githubusercontent.com/nextcloud/talk-android/$stableBranch/scripts/analysis/lint-results.txt)
+    lintResultOld=$(curl 2>/dev/null "https://raw.githubusercontent.com/nextcloud/$repository-android/$stableBranch/scripts/analysis/lint-results.txt")
     lintErrorOld=$(echo $lintResultOld | grep "[0-9]* error" -o | cut -f1 -d" ")
     lintErrorOld=$(echo $lintResultOld | grep "[0-9]* error" -o | cut -f1 -d" ")
     if ( [ -z $lintErrorOld ] ); then
     if ( [ -z $lintErrorOld ] ); then
         lintErrorOld=0
         lintErrorOld=0
@@ -95,37 +88,59 @@ else
         lintWarningOld=0
         lintWarningOld=0
     fi
     fi
 
 
-    lintResult="<h1>Lint</h1><table width='500' cellpadding='5' cellspacing='2'><tr class='tablerow0'><td>Type</td><td><a href='https://www.kaminsky.me/nc-dev/"$repository"-lint/"$stableBranch".html'>$stableBranch</a></td><td><a href='https://www.kaminsky.me/nc-dev/"$repository"-lint/"$6".html'>PR</a></td></tr><tr class='tablerow1'><td>Warnings</td><td>"$lintWarningOld"</td><td>"$lintWarningNew"</td></tr><tr class='tablerow0'><td>Errors</td><td>"$lintErrorOld"</td><td>"$lintErrorNew"</td></tr></table>"
-    findbugsResultNew=$(sed -n "/<h1>Summary<\/h1>/,/<h1>Warnings<\/h1>/p" app/build/reports/spotbugs/spotbugs.html |head -n-1 | sed s'/<\/a>//'g | sed s'/<a.*>//'g | sed s"#Summary#<a href=\"https://www.kaminsky.me/nc-dev/$repository-findbugs/$6.html\">SpotBugs</a> (new)#" | tr "\"" "\'" | tr -d "\n")
-    findbugsResultOld=$(curl -k 2>/dev/null https://www.kaminsky.me/nc-dev/$repository-findbugs/findbugs-summary-$stableBranch.html | tr "\"" "\'" | tr -d "\r\n" | sed s"#SpotBugs#<a href=\"https://www.kaminsky.me/nc-dev/$repository-findbugs/$stableBranch.html\">SpotBugs</a>#" | tr "\"" "\'" | tr -d "\n")
+    if [ $stableBranch = "master" ] ; then
+        codacyValue=$(curl 2>/dev/null https://app.codacy.com/gh/nextcloud/$repository-android/dashboard | grep "total issues" | cut -d">" -f3 | cut -d"<" -f1)
+        codacyResult="<h1>Codacy</h1>$codacyValue"
+    else
+        codacyResult=""
+    fi
+
+    lintResult="<h1>Lint</h1><table width='500' cellpadding='5' cellspacing='2'><tr class='tablerow0'><td>Type</td><td><a href='https://www.kaminsky.me/nc-dev/$repository-lint/$stableBranch.html'>$stableBranch</a></td><td><a href='https://www.kaminsky.me/nc-dev/$repository-lint/${BUILD_NUMBER}.html'>PR</a></td></tr><tr class='tablerow1'><td>Warnings</td><td>$lintWarningOld</td><td>$lintWarningNew</td></tr><tr class='tablerow0'><td>Errors</td><td>$lintErrorOld</td><td>$lintErrorNew</td></tr></table>"
 
 
+    spotbugsResult="<h1>SpotBugs</h1>$(scripts/analysis/spotbugsComparison.py "/tmp/$stableBranch.xml" app/build/reports/spotbugs/gplayDebug.xml --link-new "https://www.kaminsky.me/nc-dev/$repository-findbugs/${BUILD_NUMBER}.html" --link-base "https://www.kaminsky.me/nc-dev/$repository-findbugs/$stableBranch.html")"
 
 
     if ( [ $lintValue -eq 1 ] ) ; then
     if ( [ $lintValue -eq 1 ] ) ; then
         lintMessage="<h1>Lint increased!</h1>"
         lintMessage="<h1>Lint increased!</h1>"
     fi
     fi
 
 
-    if ( [ $findbugsValue -eq 1 ] ) ; then
-        findbugsMessage="<h1>SpotBugs increased!</h1>"
+    if ( [ $spotbugsValue -eq 1 ] ) ; then
+        spotbugsMessage="<h1>SpotBugs increased!</h1>"
+    fi
+
+    # check gplay limitation: all changelog files must only have 500 chars
+    gplayLimitation=$(scripts/checkGplayLimitation.sh)
+
+    if [ ! -z "$gplayLimitation" ]; then
+        gplayLimitation="<h1>Following files are beyond 500 char limit:</h1><br><br>"$gplayLimitation
     fi
     fi
 
 
     # check for NotNull
     # check for NotNull
-    if [[ $(grep org.jetbrains.annotations src/main/* -ir -c) -gt 0 ]] ; then
+    if [[ $(grep org.jetbrains.annotations app/src/main/* -irl | wc -l) -gt 0 ]] ; then
         notNull="org.jetbrains.annotations.NotNull is used. Please use androidx.annotation.NonNull instead.<br><br>"
         notNull="org.jetbrains.annotations.NotNull is used. Please use androidx.annotation.NonNull instead.<br><br>"
     fi
     fi
 
 
-    curl -k -u $1:$2 -X POST https://api.github.com/repos/nextcloud/talk-android/issues/$7/comments -d "{ \"body\" : \"$lintResult $findbugsResultNew $findbugsResultOld $lintMessage $findbugsMessage $notNull\" }"
+    payload="{ \"body\" : \"$codacyResult $lintResult $spotbugsResult $checkLibraryMessage $lintMessage $spotbugsMessage $gplayLimitation $notNull\" }"
+    curl_gh -X POST "https://api.github.com/repos/nextcloud/$repository-android/issues/${PR_NUMBER}/comments" -d "$payload"
+
+    if [ ! -z "$gplayLimitation" ]; then
+        exit 1
+    fi
+
+    if [ $checkLibrary -eq 1 ]; then
+        exit 1
+    fi
 
 
     if [ ! $lintValue -eq 2 ]; then
     if [ ! $lintValue -eq 2 ]; then
         exit $lintValue
         exit $lintValue
     fi
     fi
 
 
-    if [[ -n $notNull ]]; then
+    if [ -n "$notNull" ]; then
         exit 1
         exit 1
     fi
     fi
 
 
-    if [ $findbugsValue -eq 2 ]; then
+    if [ $spotbugsValue -eq 2 ]; then
         exit 0
         exit 0
     else
     else
-        exit $findbugsValue
+        exit $spotbugsValue
     fi
     fi
 fi
 fi

+ 1 - 1
scripts/analysis/findbugs-up.rb

@@ -39,7 +39,7 @@ require 'open3'
 begin
 begin
     gem "xml-simple"
     gem "xml-simple"
     rescue LoadError
     rescue LoadError
-    system("gem install xml-simple")
+    system("gem install --user-install xml-simple")
     Gem.clear_paths
     Gem.clear_paths
 end
 end
 
 

+ 11 - 24
scripts/analysis/lint-up.rb

@@ -1,14 +1,14 @@
 ## Script from https://github.com/tir38/android-lint-entropy-reducer at 07.05.2017
 ## Script from https://github.com/tir38/android-lint-entropy-reducer at 07.05.2017
 # adapts to drone, use git username / token as parameter
 # adapts to drone, use git username / token as parameter
 
 
+# TODO cleanup this script, it has a lot of unused stuff
+
+
 Encoding.default_external = Encoding::UTF_8
 Encoding.default_external = Encoding::UTF_8
 Encoding.default_internal = Encoding::UTF_8
 Encoding.default_internal = Encoding::UTF_8
 
 
 puts "=================== starting Android Lint Entropy Reducer ===================="
 puts "=================== starting Android Lint Entropy Reducer ===================="
 
 
-# get args
-git_user, git_token, git_branch = ARGV
-
 # ========================  SETUP ============================
 # ========================  SETUP ============================
 
 
 # User name for git commits made by this script.
 # User name for git commits made by this script.
@@ -39,7 +39,7 @@ require 'open3'
 begin
 begin
     gem "xml-simple"
     gem "xml-simple"
     rescue LoadError
     rescue LoadError
-    system("gem install xml-simple")
+    system("gem install --user-install xml-simple")
     Gem.clear_paths
     Gem.clear_paths
 end
 end
 
 
@@ -56,12 +56,12 @@ end
 
 
 # run Lint
 # run Lint
 puts "running Lint..."
 puts "running Lint..."
-system './gradlew --console=plain lintGplayDebug'
+system './gradlew clean lintGplayDebug 1>/dev/null'
 
 
 # confirm that Lint ran w/out error
 # confirm that Lint ran w/out error
 result = $?.to_i
 result = $?.to_i
 if result != 0
 if result != 0
-    puts "FAIL: failed to run ./gradlew --console=plain lintGplayDebug"
+    puts "FAIL: failed to run ./gradlew clean lintGplayDebug"
     exit 1
     exit 1
 end
 end
 
 
@@ -169,31 +169,18 @@ end
 # write new results to file (will overwrite existing, or create new)
 # write new results to file (will overwrite existing, or create new)
 File.write(previous_lint_report, "DO NOT TOUCH; GENERATED BY DRONE\n" + error_warning_string)
 File.write(previous_lint_report, "DO NOT TOUCH; GENERATED BY DRONE\n" + error_warning_string)
 
 
-# push changes to github (if this script is run locally, we don't want to overwrite git username and email, so save temporarily)
-previous_git_username, _ = Open3.capture2('git config user.name')
-previous_git_username = previous_git_username.strip
-
-previous_git_email, _ = Open3.capture3('git config user.email')
-previous_git_email = previous_git_email.strip
-
 # update git user name and email for this script
 # update git user name and email for this script
-system ("git config --local user.name '"  + git_user + "'")
-system ("git config --local user.email '.'") # set email blank
-system ("git remote rm origin")
-system ("git remote add origin https://" + git_user + ":" + git_token + "@github.com/nextcloud/talk-android")
+system ("git config --local user.name 'github-actions'")
+system ("git config --local user.email 'github-actions@github.com'")
 
 
 # add previous Lint result file to git
 # add previous Lint result file to git
 system ('git add ' + PREVIOUS_LINT_RESULTS_FILE)
 system ('git add ' + PREVIOUS_LINT_RESULTS_FILE)
 
 
-# commit changes; Add "skip ci" so that we don't accidentally trigger another Drone build
-system({"GIT_COMMITTER_EMAIL" => "drone@nextcloud.com", "GIT_AUTHOR_EMAIL" => "drone@nextcloud.com"}, 'git commit -sm "Drone: update Lint results to reflect reduced error/warning count [skip ci]"')
+# commit changes
+system('git commit -sm "Analysis: update lint results to reflect reduced error/warning count"')
 
 
 # push to origin
 # push to origin
-system ('git push origin HEAD:' + git_branch)
-
-# restore previous git user name and email
-system("git config --local user.name '#{previous_git_username}'")
-system("git config --local user.email '#{previous_git_email}'")
+system ('git push')
 
 
 puts "SUCCESS: count was reduced"
 puts "SUCCESS: count was reduced"
 exit 0 # success
 exit 0 # success

+ 48 - 0
scripts/analysis/spotbugs-up.rb

@@ -0,0 +1,48 @@
+## Script originally from https://github.com/tir38/android-lint-entropy-reducer at 07.05.2017
+# heavily modified since then
+
+Encoding.default_external = Encoding::UTF_8
+Encoding.default_internal = Encoding::UTF_8
+
+puts "=================== starting Android Spotbugs Entropy Reducer ===================="
+
+# get args
+base_branch = ARGV[0]
+
+require 'fileutils'
+require 'pathname'
+require 'open3'
+
+# run Spotbugs
+puts "running Spotbugs..."
+system './gradlew spotbugsGplayDebug 1>/dev/null 2>&1'
+
+# find number of warnings
+current_warning_count = `./scripts/analysis/spotbugsSummary.py --total`.to_i
+puts "found warnings: " + current_warning_count.to_s
+
+# get warning counts from target branch
+previous_xml = "/tmp/#{base_branch}.xml"
+previous_results = File.file?(previous_xml)
+
+if previous_results == true
+    previous_warning_count = `./scripts/analysis/spotbugsSummary.py --total --file #{previous_xml}`.to_i
+    puts "previous warnings: " + previous_warning_count.to_s
+end
+
+# compare previous warning count with current warning count
+if previous_results == true && current_warning_count > previous_warning_count
+    puts "FAIL: warning count increased"
+    exit 1
+end
+
+# check if warning and error count stayed the same
+if  previous_results == true && current_warning_count == previous_warning_count
+    puts "SUCCESS: count stayed the same"
+    exit 0
+end
+
+# warning count DECREASED
+if previous_results == true && current_warning_count < previous_warning_count
+    puts "SUCCESS: count decreased from " + previous_warning_count.to_s + " to " + current_warning_count.to_s
+end

+ 52 - 0
scripts/analysis/spotbugsComparison.py

@@ -0,0 +1,52 @@
+#!/usr/bin/env python3
+import argparse
+import defusedxml.ElementTree as ET
+import spotbugsSummary
+
+
+def print_comparison(old: dict, new: dict, link_base: str, link_new: str):
+    all_keys = sorted(set(list(old.keys()) + list(new.keys())))
+
+    output = "<table><tr><th>Category</th>"
+    old_header = f"<a href='{link_base}'>Base</a>" if link_base is not None else "Base"
+    output += f"<th>{old_header}</th>"
+    new_header = f"<a href='{link_new}'>New</a>" if link_new is not None else "New"
+    output += f"<th>{new_header}</th>"
+    output += "</tr>"
+
+    for category in all_keys:
+        category_count_old = old[category] if category in old else 0
+        category_count_new = new[category] if category in new else 0
+        new_str = f"<b>{category_count_new}</b>" if category_count_new != category_count_old else str(category_count_new)
+        output += "<tr>"
+        output += f"<td>{category}</td>"
+        output += f"<td>{category_count_old}</td>"
+        output += f"<td>{new_str}</td>"
+        output += "</tr>"
+
+    output += "<tr>"
+    output += "<td><b>Total</b></td>"
+    output += f"<td><b>{sum(old.values())}</b></td>"
+    output += f"<td><b>{sum(new.values())}</b></td>"
+    output += "</tr>"
+
+    output += "</table>"
+
+    print(output)
+
+
+if __name__ == "__main__":
+    parser = argparse.ArgumentParser()
+    parser.add_argument("base_file", help="base file for comparison")
+    parser.add_argument("new_file", help="new file for comparison")
+    parser.add_argument("--link-base", help="http link to base html report")
+    parser.add_argument("--link-new", help="http link to new html report")
+    args = parser.parse_args()
+
+    base_tree = ET.parse(args.base_file)
+    base_summary = spotbugsSummary.get_counts(base_tree)
+
+    new_tree = ET.parse(args.new_file)
+    new_summary = spotbugsSummary.get_counts(new_tree)
+
+    print_comparison(base_summary, new_summary, args.link_base, args.link_new)

+ 61 - 0
scripts/analysis/spotbugsSummary.py

@@ -0,0 +1,61 @@
+#!/usr/bin/env python3
+import argparse
+import defusedxml.ElementTree as ET
+
+
+def get_counts(tree):
+    category_counts = {}
+    category_names = {}
+    for child in tree.getroot():
+        if child.tag == "BugInstance":
+            category = child.attrib['category']
+            if category in category_counts:
+                category_counts[category] = category_counts[category] + 1
+            else:
+                category_counts[category] = 1
+        elif child.tag == "BugCategory":
+            category = child.attrib['category']
+            category_names[category] = child[0].text
+
+    summary = {}
+    for category in category_counts.keys():
+        summary[category_names[category]] = category_counts[category]
+    return summary
+
+
+def print_html(summary):
+    output = "<table><tr><th>Category</th><th>Count</th></tr>"
+
+    categories = sorted(summary.keys())
+    for category in categories:
+        output += "<tr>"
+        output += f"<td>{category}</td>"
+        output += f"<td>{summary[category]}</td>"
+        output += "</tr>"
+
+    output += "<tr>"
+    output += "<td><b>Total</b></td>"
+    output += f"<td><b>{sum(summary.values())}</b></td>"
+    output += "</tr>"
+
+    output += "</table>"
+
+    print(output)
+
+
+def print_total(summary):
+    print(sum(summary.values()))
+
+
+if __name__ == "__main__":
+    parser = argparse.ArgumentParser()
+    parser.add_argument("--total", help="print total count instead of summary HTML",
+                        action="store_true")
+    parser.add_argument("--file", help="file to parse", default="app/build/reports/spotbugs/gplayDebug.xml")
+    args = parser.parse_args()
+    tree = ET.parse(args.file)
+    summary = get_counts(tree)
+    if args.total:
+        print_total(summary)
+    else:
+        print_html(summary)

+ 48 - 0
scripts/lib.sh

@@ -0,0 +1,48 @@
+#!/usr/bin/env bash
+#
+#  Nextcloud Android Library is available under MIT license
+#
+#  @author Álvaro Brey Vilas
+#  Copyright (C) 2022 Álvaro Brey Vilas
+#  Copyright (C) 2022 Nextcloud GmbH
+#
+#  Permission is hereby granted, free of charge, to any person obtaining a copy
+#  of this software and associated documentation files (the "Software"), to deal
+#  in the Software without restriction, including without limitation the rights
+#  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+#  copies of the Software, and to permit persons to whom the Software is
+#  furnished to do so, subject to the following conditions:
+#
+#  The above copyright notice and this permission notice shall be included in
+#  all copies or substantial portions of the Software.
+#
+#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+#  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+#  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+#  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
+#  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
+#  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
+#  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+#  THE SOFTWARE.
+#
+
+## This file is intended to be sourced by other scripts
+
+
+function err() {
+    echo >&2 "$@"
+}
+
+
+function curl_gh() {
+    if [[ -n "$GITHUB_TOKEN" ]]
+    then
+        curl \
+            --silent \
+            --header "Authorization: token $GITHUB_TOKEN" \
+            "$@"
+    else
+        err "WARNING: No GITHUB_TOKEN found. Skipping API call"
+    fi
+
+}